#property copyright "Copyright  2008, ForexSoft Team"
#property link      "http://forexsoft.us"

#include <stdlib.mqh>

extern int CheckHour = 9;
extern int Hours2Check = 1;
extern int CloseHour = 15;
int gi_88 = 7;
int gi_92 = 7;
extern int CheckMode = 1;
extern double ChannelK = 0.9;
extern double ProfitK = 1.0;
extern double LossK = 4.0;
extern double OffsetK = 2.0;
extern bool UseMM = false;
string gs_unused_136 = "GoldNStream";
int gi_unused_144 = 118;
int gi_148 = 1;
int gi_152 = 10;
extern double g_lots_156 = 0.1;
int gi_164 = 22;
int gi_168 = 5;
int gi_172 = 10;
int gi_176;
int g_error_180;
int g_ticket_188;
bool g_ord_close_192;
int gi_196;
int gi_200;
int gi_204;
int gi_208;
int gi_212;
int gi_216;
int g_pos_220;
int g_day_224;
int g_day_228;
int gi_232;
int gi_236;
double gd_240;
double gd_248;
double gda_256[30];
double gd_260;
double gd_268;
double gd_276;
double gd_284;

int init() {
   gi_200 = gi_92;
   return (0);
}

int deinit() {
   Comment("");
   return (0);
}

void Levels_Defining() {
   gi_232 = 60 * Hours2Check / Period();
   gd_260 = High[iHighest(NULL, 0, MODE_HIGH, gi_232, 1)];
   gd_268 = Low[iLowest(NULL, 0, MODE_LOW, gi_232, 1)];
   gi_236 = 1440 / Period();
   gd_276 = 0;
   gd_284 = gd_260 - gd_268;
   if (gi_88 == 2) gi_92 = DayOfWeek() + gi_200;
   if (CheckMode == 1) {
      for (g_pos_220 = 1; g_pos_220 <= gi_92; g_pos_220++) {
         gda_256[g_pos_220] = High[iHighest(NULL, 0, MODE_HIGH, gi_236, gi_236 * g_pos_220 + 1)] - Low[iLowest(NULL, 0, MODE_LOW, gi_236, gi_236 * g_pos_220 + 1)];
         gd_276 += gda_256[g_pos_220];
         gi_216 = MathRound(gd_276 / g_pos_220 / Point);
      }
   }
   if (CheckMode == 2) {
      for (g_pos_220 = 1; g_pos_220 <= gi_92; g_pos_220++) {
         gda_256[g_pos_220] = MathAbs(Close[gi_236 * g_pos_220 + gi_232] - (Close[gi_236 * (g_pos_220 - 1) + gi_232]));
         gd_276 += gda_256[g_pos_220];
         gi_216 = MathRound(gd_276 / g_pos_220 / Point);
      }
   }
   gi_212 = MathRound(gi_216 / OffsetK);
   gd_240 = NormalizeDouble(gd_268 - gi_212 * Point, 4);
   gd_248 = NormalizeDouble(gd_260 + gi_212 * Point, 4);
}

void Close_by_Closetime() {
   for (g_pos_220 = 0; g_pos_220 < OrdersTotal(); g_pos_220++) {
      if (OrderSelect(g_pos_220, SELECT_BY_POS, MODE_TRADES) == FALSE) break;
      if (OrderMagicNumber() != 111 || OrderSymbol() != Symbol()) continue;
      if (OrderType() == OP_BUY) {
         for (int li_0 = 1; li_0 <= gi_168; li_0++) {
            while (!IsTradeAllowed()) Sleep(5000);
            g_ord_close_192 = FALSE;
            RefreshRates();
            g_ord_close_192 = OrderClose(OrderTicket(), g_lots_156, Bid, 3, White);
            Sleep(gi_176);
            if (g_ord_close_192) {
               gi_176 = 1000;
               break;
            }
            g_error_180 = GetLastError();
            Print("OrderClose failed with error #", g_error_180, " : ", ErrorDescription(g_error_180), "Trying Again #", li_0);
            gi_176 <<= 1;
            if (li_0 == gi_168) {
               gi_176 = 1000;
               Print("Warning!!!Last try failed!");
               //SendMail("Warning!!!Last try failed!  ", OrderType() + " by " + OrderClosePrice() + " Cloing Failed!");
               break;
            }
         }
      }
      if (OrderType() == OP_SELL) {
         for (li_0 = 1; li_0 <= gi_168; li_0++) {
            while (!IsTradeAllowed()) Sleep(5000);
            g_ord_close_192 = FALSE;
            RefreshRates();
            g_ord_close_192 = OrderClose(OrderTicket(), g_lots_156, Ask, 3, White);
            Sleep(gi_176);
            if (g_ord_close_192) {
               gi_176 = 1000;
               break;
            }
            g_error_180 = GetLastError();
            Print("OrderClose failed with error #", g_error_180, " : ", ErrorDescription(g_error_180), "Trying Again #", li_0);
            gi_176 <<= 1;
            if (li_0 == gi_168) {
               gi_176 = 1000;
               Print("Warning!!!Last try failed!");
               //SendMail("Warning!!!Last try failed!  ", OrderType() + " by " + OrderClosePrice() + " Cloing Failed!");
               break;
            }
         }
      }
   }
}

void Close_by_Stops() {
   for (g_pos_220 = 0; g_pos_220 < OrdersTotal(); g_pos_220++) {
      if (OrderSelect(g_pos_220, SELECT_BY_POS, MODE_TRADES) == FALSE) break;
      if (OrderMagicNumber() != 111 || OrderSymbol() != Symbol()) continue;
      if (OrderType() == OP_BUY && Close[1] - NormalizeDouble(OrderOpenPrice(), 4) >= gi_204 * Point || NormalizeDouble(OrderOpenPrice(), 4) - Close[1] >= gi_208 * Point) {
         for (int li_0 = 1; li_0 <= gi_168; li_0++) {
            while (!IsTradeAllowed()) Sleep(5000);
            g_ord_close_192 = FALSE;
            RefreshRates();
            g_ord_close_192 = OrderClose(OrderTicket(), g_lots_156, Bid, 3, White);
            Sleep(gi_176);
            if (g_ord_close_192) {
               gi_176 = 1000;
               break;
            }
            g_error_180 = GetLastError();
            Print("OrderClose failed with error #", g_error_180, " : ", ErrorDescription(g_error_180), "Trying Again #", li_0);
            gi_176 <<= 1;
            if (li_0 == gi_168) {
               gi_176 = 1000;
               Print("Warning!!!Last try failed!");
               //SendMail("Warning!!!Last try failed!  ", OrderType() + " by " + OrderClosePrice() + " Cloing Failed!");
               break;
            }
         }
      }
      if (OrderType() == OP_SELL && Close[1] - NormalizeDouble(OrderOpenPrice(), 4) >= gi_208 * Point || NormalizeDouble(OrderOpenPrice(), 4) - Close[1] >= gi_204 * Point) {
         for (li_0 = 1; li_0 <= gi_168; li_0++) {
            while (!IsTradeAllowed()) Sleep(5000);
            g_ord_close_192 = FALSE;
            RefreshRates();
            g_ord_close_192 = OrderClose(OrderTicket(), g_lots_156, Ask, 3, White);
            Sleep(gi_176);
            if (g_ord_close_192) {
               gi_176 = 1000;
               break;
            }
            g_error_180 = GetLastError();
            Print("OrderClose failed with error #", g_error_180, " : ", ErrorDescription(g_error_180), "Trying Again #", li_0);
            gi_176 <<= 1;
            if (li_0 == gi_168) {
               gi_176 = 1000;
               Print("Warning!!!Last try failed!");
               //SendMail("Warning!!!Last try failed!  ", OrderType() + " by " + OrderClosePrice() + " Cloing Failed!");
               break;
            }
         }
      }
   }
}

double LotSizeCounting() 
{
   if (UseMM == TRUE) 
   {
      g_lots_156 = NormalizeDouble(AccountFreeMargin() / 100.0 * gi_152 / (gi_208 * gi_148 * gi_172), 1);
      if (g_lots_156 < 0.1) 
      {
         Print("Too risky Trade! Add some money to account");
         //SendMail("Too risky Trade! Add some money to account", "Too risky Trade! Add some money to account");
      }
   } 
   //else g_lots_156 = 0.1;
   return (g_lots_156);
}

void Opening() {
   gi_204 = MathRound(gi_216 / ProfitK);
   gi_208 = MathRound(gi_216 / LossK);
   gi_196 = MathRound(1.5 * gi_208);
   if (Close[1] >= gd_248) {
      for (int li_0 = 1; li_0 <= gi_168; li_0++) {
         while (!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         g_lots_156 = LotSizeCounting();
         g_ticket_188 = OrderSend(Symbol(), OP_BUY, g_lots_156, Ask, 3, Ask - gi_196 * Point, 1.5, "", 111, 16711680);
         Sleep(gi_176);
         if (g_ticket_188 > 0) {
            g_day_228 = Day();
            gi_176 = 1000;
            break;
         }
         g_error_180 = GetLastError();
         Print("OrderSend failed with error #", g_error_180, " : ", ErrorDescription(g_error_180), "Trying again #", li_0);
         gi_176 <<= 1;
         if (li_0 == gi_168) {
            gi_176 = 1000;
            Print("Warning!!!Last try failed!");
            //SendMail("Warning!!!Last try failed!", OrderType() + " by " + OrderOpenPrice() + " Opening failed!");
            break;
         }
      }
   }
   if (gd_240 >= Close[1]) {
      for (li_0 = 1; li_0 <= gi_168; li_0++) {
         while (!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         g_lots_156 = LotSizeCounting();
         g_ticket_188 = OrderSend(Symbol(), OP_SELL, g_lots_156, Bid, 3, Bid + gi_196 * Point, 1, "", 111, 255);
         Sleep(gi_176);
         if (g_ticket_188 > 0) {
            g_day_228 = Day();
            gi_176 = 1000;
            return;
         }
         g_error_180 = GetLastError();
         Print("OrderSend failed with error #", g_error_180, " : ", ErrorDescription(g_error_180), "Trying again #", li_0);
         gi_176 <<= 1;
         if (li_0 == gi_168) {
            gi_176 = 1000;
            Print("Warning!!!Last try failed!");
            //SendMail("Warning!!!Last try failed!", OrderType() + " by " + OrderOpenPrice() + " Opening failed!");
            return;
         }
      }
   }
}

void start() {

      if (Hour() == CheckHour) {
         Levels_Defining();
         g_day_224 = Day();
      }
      if (OrdersTotal() > 0) {
         Close_by_Stops();
         if (Hour() >= CloseHour && Day() != g_day_228) Close_by_Closetime();
      }
      if (Hour() <= gi_164) {
         if (Day() == g_day_224) {
            if (Day() != g_day_228)
               if (OrdersTotal() == 0 && gd_284 < gi_216 / ChannelK * Point) Opening();
         }
      }
}

